require "util"

script.on_init(function()
  if global.ts == nil then
    global.ts = {}
	global.ts.growing = {}
  end
end)

script.on_load(function()
  if global.ts == nil then
    global.ts = {}
	global.ts.growing = {}
  end
end)

script.on_event(defines.events.on_built_entity, function(event)
  if event.created_entity.name == "sapling" then
    global.ts.growing[event.created_entity.position] = math.floor(game.tick / 60)
  end
end)

script.on_event(defines.events.on_tick, function(event)
  if game.tick % 60 == 0 then
    for k, v in pairs(global.ts.growing) do
      if math.random() < ((game.tick / 60) - (v + 60)) / 3600 then
        local foundtree = false
		local entities = game.surfaces[1].find_entities_filtered{area = {{k.x - .25, k.y - .25}, {k.x + .25, k.y + .25}}, name = 'sapling'}
		for _,entity in pairs(entities) do
          entity.destroy()
          foundtree = true
        end
        
        local treetype = math.random(6)
        if treetype == 6 then
          treetype = "tree-02-red"
        else
          treetype = "tree-0".. treetype
        end
        if foundtree then
          game.surfaces[1].create_entity({ name=treetype, amount=1, position=k})
        end
        global.ts.growing[k] = nil
      end
    end
  end
end)